VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CTripleClick"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Implements iSuperClass
'CTripleClick: subclasses a window and provides triple click notifications to any listening event sinks.

'requires iSuperClass and cSuperClass.

Private Declare Function GetDoubleClickTime Lib "user32.dll" () As Long
Private Declare Function timeGetTime Lib "winmm.dll" () As Long
Private Declare Function GetMessageTime Lib "user32.dll" () As Long
Private Declare Sub CopyMemory _
                Lib "kernel32.dll" _
                Alias "RtlMoveMemory" (ByRef Destination As Any, _
                                       ByRef Source As Any, _
                                       ByVal Length As Long)
Public Event TripleClick(ByVal Button As Integer, ByVal X As Integer, ByVal Y As Integer)
Private mSubclasser         As cSuperClass
Private mDblClickTime       As Long
Private mLastLeftDblClick   As Long
Private mLastRightDblClick  As Long
Private mLastMiddleDblClick As Long

Public Sub Init(ByVal OnWnd As Long)

    If Not mSubclasser Is Nothing Then
        mSubclasser.UnSubclass
        Set mSubclasser = Nothing
    End If

    Set mSubclasser = New cSuperClass
    mDblClickTime = GetDoubleClickTime()
    mSubclasser.AddMessages True, CWM_LBUTTONDBLCLK, CWM_RBUTTONDBLCLK, CWM_MBUTTONDBLCLK, CWM_LBUTTONDOWN, CWM_LBUTTONUP, CWM_RBUTTONDOWN, CWM_RBUTTONUP, CWM_MBUTTONDOWN, CWM_MBUTTONUP, CWM_WININICHANGE
    
    mSubclasser.Subclass OnWnd, Me, False

End Sub

Private Sub Class_Initialize()
    mDblClickTime = GetDoubleClickTime
End Sub

Private Sub Class_Terminate()
    mSubclasser.UnSubclass
End Sub

Private Sub iSuperClass_After(lReturn As Long, _
                              ByVal hwnd As Long, _
                              ByVal uMsg As Long, _
                              ByVal wParam As Long, _
                              ByVal lParam As Long)

End Sub

Private Sub iSuperClass_Before(lHandled As Long, _
                               lReturn As Long, _
                               ByVal hwnd As Long, _
                               ByVal uMsg As Long, _
                               ByVal wParam As Long, _
                               ByVal lParam As Long)
    '
    '
    'On double-click, record the time of the double click; if a button down message,
    'see if the last double click time for that message is within the double-click tolerance time.
    'If so, raise the tripleclick event.

    'Debug.Print "after"
    Dim MessageTime As Long

    MessageTime = GetMessageTime

    Select Case uMsg

        Case CWM_MBUTTONDBLCLK
            mLastMiddleDblClick = MessageTime
        
        Case CWM_LBUTTONDBLCLK
            mLastLeftDblClick = MessageTime

        Case CWM_RBUTTONDBLCLK
            mLastRightDblClick = MessageTime

        Case CWM_LBUTTONDOWN

            If MessageTime - mLastLeftDblClick < mDblClickTime Then
                'reduce the lastdblclick time by the doubleclick interval, to prevent a subsequent click from erroneously firing this message again.
                mLastLeftDblClick = 0
                RaiseTripleClick vbLeftButton, lParam
        
            End If

        Case CWM_RBUTTONDOWN

            If MessageTime - mLastRightDblClick < mDblClickTime Then
                mLastRightDblClick = 0
                RaiseTripleClick vbRightButton, lParam
            End If

        Case CWM_MBUTTONDOWN

            If MessageTime - mLastMiddleDblClick < mDblClickTime Then
                mLastMiddleDblClick = 0
                RaiseTripleClick vbMiddleButton, lParam
            End If

        Case CWM_WININICHANGE
            mDblClickTime = GetDoubleClickTime()

    End Select

End Sub

Private Sub RaiseTripleClick(ByVal Button As Long, ByVal lParam As Long)

    Dim useX As Integer, UseY As Integer

    GetHiLoWord lParam, useX, UseY

    RaiseEvent TripleClick(Button, useX, UseY)

End Sub

'lParam
'    The low-order word specifies the x-coordinate of the cursor. The coordinate is relative to the upper-left corner of the client area.
'
'    The high-order word specifies the y-coordinate of the cursor. The coordinate is relative to the upper-left corner of the client area.
Private Sub GetHiLoWord(ByVal OnLong As Long, LoWord As Integer, HighWord As Integer)

    CopyMemory LoWord, OnLong, 2
    CopyMemory HighWord, ByVal VarPtr(OnLong) + 2, 2

End Sub
